"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.togglePalette = void 0;
var _analytics = require("@atlaskit/editor-common/analytics");
var _main = require("../pm-plugins/main");
var togglePalette = exports.togglePalette = function togglePalette(api) {
  return function (state, dispatch) {
    var _highlightPluginKey$g, _highlightPluginKey$g2;
    var isDisabled = (_highlightPluginKey$g = _main.highlightPluginKey.getState(state)) === null || _highlightPluginKey$g === void 0 ? void 0 : _highlightPluginKey$g.disabled;
    var isPaletteOpen = (_highlightPluginKey$g2 = _main.highlightPluginKey.getState(state)) === null || _highlightPluginKey$g2 === void 0 ? void 0 : _highlightPluginKey$g2.isPaletteOpen;
    var tr = state.tr;
    if (!isDisabled) {
      var _api$analytics;
      (_api$analytics = api.analytics) === null || _api$analytics === void 0 || _api$analytics.actions.attachAnalyticsEvent(createAnalyticsEvent(!isPaletteOpen))(tr);
      tr.setMeta(_main.highlightPluginKey, {
        type: _main.HighlightPluginAction.TOGGLE_PALETTE,
        isPaletteOpen: !isPaletteOpen
      });
      if (dispatch) {
        dispatch(tr);
      }
      return true;
    }
    return false;
  };
};
var createAnalyticsEvent = function createAnalyticsEvent(isOpen) {
  return {
    action: isOpen ? _analytics.ACTION.OPENED : _analytics.ACTION.CLOSED,
    actionSubject: _analytics.ACTION_SUBJECT.TOOLBAR,
    actionSubjectId: _analytics.ACTION_SUBJECT_ID.FORMAT_BACKGROUND_COLOR,
    eventType: _analytics.EVENT_TYPE.TRACK,
    attributes: {
      inputMethod: _analytics.INPUT_METHOD.SHORTCUT
    }
  };
};