import { ACTION, ACTION_SUBJECT, ACTION_SUBJECT_ID, EVENT_TYPE, INPUT_METHOD } from '@atlaskit/editor-common/analytics';
import { HighlightPluginAction, highlightPluginKey } from '../pm-plugins/main';
export const setPalette = (api, isPaletteOpen) => (state, dispatch) => {
  var _highlightPluginKey$g;
  const isDisabled = (_highlightPluginKey$g = highlightPluginKey.getState(state)) === null || _highlightPluginKey$g === void 0 ? void 0 : _highlightPluginKey$g.disabled;
  if (!isDisabled) {
    var _api$analytics;
    const tr = state.tr;
    (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions.attachAnalyticsEvent(createAnalyticsEvent(isPaletteOpen))(tr);
    tr.setMeta(highlightPluginKey, {
      type: HighlightPluginAction.TOGGLE_PALETTE,
      isPaletteOpen
    });
    if (dispatch) {
      dispatch(tr);
    }
    return true;
  }
  return false;
};
const createAnalyticsEvent = isOpen => {
  return {
    action: isOpen ? ACTION.OPENED : ACTION.CLOSED,
    actionSubject: ACTION_SUBJECT.TOOLBAR,
    actionSubjectId: ACTION_SUBJECT_ID.FORMAT_BACKGROUND_COLOR,
    eventType: EVENT_TYPE.TRACK,
    attributes: {
      inputMethod: INPUT_METHOD.TOOLBAR
    }
  };
};