import { ACTION, ACTION_SUBJECT, ACTION_SUBJECT_ID, EVENT_TYPE, INPUT_METHOD } from '@atlaskit/editor-common/analytics';
import { HighlightPluginAction, highlightPluginKey } from '../pm-plugins/main';
export var togglePalette = function togglePalette(api) {
  return function (state, dispatch) {
    var _highlightPluginKey$g, _highlightPluginKey$g2;
    var isDisabled = (_highlightPluginKey$g = highlightPluginKey.getState(state)) === null || _highlightPluginKey$g === void 0 ? void 0 : _highlightPluginKey$g.disabled;
    var isPaletteOpen = (_highlightPluginKey$g2 = highlightPluginKey.getState(state)) === null || _highlightPluginKey$g2 === void 0 ? void 0 : _highlightPluginKey$g2.isPaletteOpen;
    var tr = state.tr;
    if (!isDisabled) {
      var _api$analytics;
      (_api$analytics = api.analytics) === null || _api$analytics === void 0 || _api$analytics.actions.attachAnalyticsEvent(createAnalyticsEvent(!isPaletteOpen))(tr);
      tr.setMeta(highlightPluginKey, {
        type: HighlightPluginAction.TOGGLE_PALETTE,
        isPaletteOpen: !isPaletteOpen
      });
      if (dispatch) {
        dispatch(tr);
      }
      return true;
    }
    return false;
  };
};
var createAnalyticsEvent = function createAnalyticsEvent(isOpen) {
  return {
    action: isOpen ? ACTION.OPENED : ACTION.CLOSED,
    actionSubject: ACTION_SUBJECT.TOOLBAR,
    actionSubjectId: ACTION_SUBJECT_ID.FORMAT_BACKGROUND_COLOR,
    eventType: EVENT_TYPE.TRACK,
    attributes: {
      inputMethod: INPUT_METHOD.SHORTCUT
    }
  };
};