import React from 'react';
import { changeColor } from './commands';
import { keymapPlugin } from './pm-plugins/keymap';
import { createPlugin, highlightPluginKey } from './pm-plugins/main';
import { ToolbarHighlightColorWithIntl as ToolbarHighlightColor } from './ui/ToolbarHighlightColor';
export var highlightPlugin = function highlightPlugin(_ref) {
  var _api$analytics;
  var api = _ref.api;
  var editorAnalyticsAPI = api === null || api === void 0 || (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  var primaryToolbarComponent = function primaryToolbarComponent(_ref2) {
    var popupsMountPoint = _ref2.popupsMountPoint,
      popupsBoundariesElement = _ref2.popupsBoundariesElement,
      popupsScrollableElement = _ref2.popupsScrollableElement,
      disabled = _ref2.disabled,
      isToolbarReducedSpacing = _ref2.isToolbarReducedSpacing,
      dispatchAnalyticsEvent = _ref2.dispatchAnalyticsEvent,
      editorView = _ref2.editorView;
    return /*#__PURE__*/React.createElement(ToolbarHighlightColor, {
      popupsMountPoint: popupsMountPoint,
      popupsBoundariesElement: popupsBoundariesElement,
      popupsScrollableElement: popupsScrollableElement,
      disabled: disabled,
      isToolbarReducedSpacing: isToolbarReducedSpacing,
      dispatchAnalyticsEvent: dispatchAnalyticsEvent,
      pluginInjectionApi: api,
      editorView: editorView
    });
  };
  return {
    name: 'highlight',
    commands: {
      changeColor: changeColor(editorAnalyticsAPI)
    },
    pmPlugins: function pmPlugins() {
      return [{
        name: 'highlight',
        plugin: function plugin() {
          return createPlugin({
            api: api
          });
        }
      }, {
        name: 'highlightKeymap',
        plugin: function plugin() {
          return keymapPlugin({
            api: api
          });
        }
      }];
    },
    getSharedState: function getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return highlightPluginKey.getState(editorState);
    },
    usePluginHook: function usePluginHook() {
      var _api$core, _api$primaryToolbar;
      api === null || api === void 0 || (_api$core = api.core) === null || _api$core === void 0 || _api$core.actions.execute(api === null || api === void 0 || (_api$primaryToolbar = api.primaryToolbar) === null || _api$primaryToolbar === void 0 ? void 0 : _api$primaryToolbar.commands.registerComponent({
        name: 'highlight',
        component: primaryToolbarComponent
      }));
    },
    primaryToolbarComponent: !(api !== null && api !== void 0 && api.primaryToolbar) ? primaryToolbarComponent : undefined
  };
};